"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServiceProvider = void 0;
var ScopedContext_1 = require("./ScopedContext");
var ServiceProvider = /** @class */ (function () {
    function ServiceProvider(lifetimes) {
        Object.defineProperty(this, "lifetimes", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "proxy", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.lifetimes = lifetimes;
        var self = this;
        this.proxy = new Proxy({}, {
            get: function (target, prop) { return self.provide(prop); },
        });
    }
    Object.defineProperty(ServiceProvider.prototype, "provide", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (selector) {
            var context = new ScopedContext_1.ScopedContext(this.lifetimes);
            return context.provide(selector);
        }
    });
    return ServiceProvider;
}());
exports.ServiceProvider = ServiceProvider;
